import * as i0 from '@angular/core';
import { input, signal, Component } from '@angular/core';
import * as i2 from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';
import * as i1 from '@angular/cdk/drag-drop';
import { CdkDrag } from '@angular/cdk/drag-drop';
import * as i3 from '@ctrl/ngx-codemirror';
import { CodemirrorModule } from '@ctrl/ngx-codemirror';
import { ControlAccessorDirective, AutofocusDirective, ToolbarFabDirective } from '@tmdjr/ngx-editor-js2';
import { CommonModule } from '@angular/common';

class NgxEditorJs2CodemirrorComponent {
    sortIndex = input(0);
    componentInstanceName = 'NgxEditorJs2CodemirrorComponent';
    autofocus = input(true);
    formGroup = input.required();
    formControlName = input.required();
    blockOptionActions = input([
        { action: 'text/typescript', icon: 'javascript' },
        { action: 'css', icon: 'css' },
        { action: 'xml', icon: 'html' },
    ]);
    codeMirrorOptions = signal({
        lineNumbers: true,
        theme: 'material-palenight',
        mode: 'text/typescript',
        extraKeys: { 'Ctrl-Space': 'autocomplete' },
    });
    savedAction = signal('display-large');
    actionCallbackBind = this.actionCallback.bind(this);
    actionCallback(action) {
        this.codeMirrorOptions.update((prev) => ({ ...prev, mode: action }));
        this.savedAction.update(() => action);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgxEditorJs2CodemirrorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgxEditorJs2CodemirrorComponent, isStandalone: true, selector: "ngx-editor-js2-codemirror", inputs: { sortIndex: { classPropertyName: "sortIndex", publicName: "sortIndex", isSignal: true, isRequired: false, transformFunction: null }, autofocus: { classPropertyName: "autofocus", publicName: "autofocus", isSignal: true, isRequired: false, transformFunction: null }, formGroup: { classPropertyName: "formGroup", publicName: "formGroup", isSignal: true, isRequired: true, transformFunction: null }, formControlName: { classPropertyName: "formControlName", publicName: "formControlName", isSignal: true, isRequired: true, transformFunction: null }, blockOptionActions: { classPropertyName: "blockOptionActions", publicName: "blockOptionActions", isSignal: true, isRequired: false, transformFunction: null } }, host: { classAttribute: "cdk-drag-animating no-toolbar-inline" }, hostDirectives: [{ directive: i1.CdkDrag }], ngImport: i0, template: `
    <ng-container [formGroup]="formGroup()">
      <span
        controlAccessor
        [autofocus]="autofocus()"
      ></span>
      <ngx-codemirror
        toolbarFab
        [actionCallback]="actionCallbackBind"
        [blockOptionActions]="blockOptionActions()"
        [formControlName]="formControlName()"
        [componentContextPositionIndex]="sortIndex()"
        [options]="codeMirrorOptions()"
      ></ngx-codemirror>
    </ng-container>
  `, isInline: true, styles: [":host{display:block;position:relative}:host .codemirror-container-overlay{display:flex;height:100%;width:100%;position:absolute}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "directive", type: ControlAccessorDirective, selector: "[controlAccessor]", inputs: ["defaultValue"] }, { kind: "directive", type: AutofocusDirective, selector: "[autofocus]", inputs: ["autofocus"] }, { kind: "directive", type: ToolbarFabDirective, selector: "[toolbarFab]", inputs: ["autofocus", "blockOptionActions", "actionCallback", "componentContextPositionIndex", "formControlName"] }, { kind: "ngmodule", type: CodemirrorModule }, { kind: "component", type: i3.CodemirrorComponent, selector: "ngx-codemirror", inputs: ["className", "name", "autoFocus", "options", "preserveScrollPosition"], outputs: ["cursorActivity", "focusChange", "scroll", "drop", "codeMirrorLoaded"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgxEditorJs2CodemirrorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-editor-js2-codemirror', host: { class: 'cdk-drag-animating no-toolbar-inline' }, hostDirectives: [CdkDrag], imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        ControlAccessorDirective,
                        AutofocusDirective,
                        ToolbarFabDirective,
                        CodemirrorModule,
                    ], template: `
    <ng-container [formGroup]="formGroup()">
      <span
        controlAccessor
        [autofocus]="autofocus()"
      ></span>
      <ngx-codemirror
        toolbarFab
        [actionCallback]="actionCallbackBind"
        [blockOptionActions]="blockOptionActions()"
        [formControlName]="formControlName()"
        [componentContextPositionIndex]="sortIndex()"
        [options]="codeMirrorOptions()"
      ></ngx-codemirror>
    </ng-container>
  `, styles: [":host{display:block;position:relative}:host .codemirror-container-overlay{display:flex;height:100%;width:100%;position:absolute}\n"] }]
        }] });

/*
 * Public API Surface of ngx-editor-js2-codemirror
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxEditorJs2CodemirrorComponent };
//# sourceMappingURL=tmdjr-ngx-editor-js2-codemirror.mjs.map
